/**************************************************************************************************

Copyright (c) 2007-2014   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_COLORS_H__
#define __MTK_COLORS_H__
#include  "../common/graphics/color.h"



enum {
	MTK_COLOR_NAME_OBJECT,
	MTK_COLOR_NAME_SPECIAL_OBJECT,
	MTK_COLOR_NAME_SATELLITE,
	MTK_COLOR_NAME_DWARF_PLANET,
	MTK_COLOR_NAME_SMALL_OBJECT,
	MTK_COLOR_NAME_SPACECRAFT,
	MTK_COLOR_ORBIT_PLANET,
	MTK_COLOR_ORBIT_SATELLITE,
	MTK_COLOR_ORBIT_DWARF_PLANET,
	MTK_COLOR_ORBIT_SMALL_OBJECT,
	MTK_COLOR_CONSTELLATION_NAME,
	MTK_COLOR_CONSTELLATION_LINE,
	MTK_COLOR_CONSTELLATION_BOUNDARY,
	MTK_COLOR_SCALE_CIRCLE,
	MTK_COLOR_SCALE_CIRCLE_TEXT,
	MTK_COLOR_SCALE_SQUARE,
	MTK_COLOR_SCALE_SQUARE_TEXT,
	MTK_COLOR_LOCATION_NAME,
	MTK_COLOR_DATE,
	MTK_COLOR_DATE_REALTIME_MODE,
	MTK_COLOR_OORT,
	MTK_COLOR_QSO
};

const int COLOR_NUM = 22;





const RGBf&		get_color(int idx);
void			load_colors_from_ini_file(const char* ini_file_path);
bool			is_colorref(const char* str);
RGBf			get_color_from_colorref(const char* str);
bool			is_RGBAref(const char* str);
RGBAf			get_RGBA_from_RGBAref(const char* str);


#endif
