/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_SCREEN_H__
#define __MTK_SCREEN_H__
#include  "../common/graphics/gl_common.h"



//-------------
//  Functions
//-------------
//--  screen --
float	get_screen_z();
float	get_screen_w();
float	get_z_near();
float	get_z_mid();
float	get_z_far();
float	get_obj_z();

void	set_screen_z(float z);
void	set_screen_w(float w);
void	set_z_near(float z);
void	set_z_mid(float z);
void	set_z_far(float z);
void	set_obj_z(float z);




//--  frustum  --
frustum	get_frustum_near(float aspc_rt);
frustum	get_frustum_far(float aspc_rt);
//--  Eye  --
float	get_eye_offset_x();
void	set_eye_offset_x(float x);
float	get_screen_offset_x();
void	set_screen_offset_x(float x);
char	get_eye_CLR();
void	set_eye_CLR(char CLR);
float	get_eye_distance();
void	set_eye_distance(float dist);
bool	is_eye_dist_change_enabled();
void	set_eye_dist_change(bool bFlg);



//--  scale  --
double	get_current_scale();
double	get_scale_last();
void	set_scale(const double& scl);

double	get_clst_R();
double	calc_scale_factor(const double& scl);
double	get_scale_factor();
float	get_Rmax();

//--  Fade angle
void	set_fade_angle_factor(float fac);
float	get_fade_angle_factor();


#endif
