/**************************************************************************************************

Written by Tsunehiko Kato
Copyright (c) 2008   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_selection.h"
#include  <set>
#include  <string>
#include  "../common/text/string_util.h"




static std::set<std::string>  selection;





void
clear_selection()
{
	selection.clear();
}


bool
load_selection_sub(FILE* fp)
{
	while (true) {
		static char buf[1024];

		if (fgets(buf, 1024, fp) == NULL) {
			if (feof(fp) != 0)  break;
			continue;
		}
		
		std::string  key = remove_cpp_comment(buf);
		key = trim(key, " \t\n");
		if (key.size() == 0) {
			continue;
		}
		
		//--  Register
		selection.insert(key);
	}

	return  true;
}




bool
load_selection(const directory& dir)
{
	FILE* fp;

	fp = fopen(dir.get_path("selection.dat"), "rt");
	if (fp == NULL)  return false;

	bool res;
	res = load_selection_sub(fp);
	fclose(fp);

	return res;
}




bool
is_selected(const std::string& key)
{
	return  (selection.find(key) != selection.end());
}


void
set_selection(const std::string& key, bool flg)
{
	if (flg) {
		selection.insert(key);
	} else{
		selection.erase(key);
	}
}
